/*  Copyright (C) 2001Bjrn Paetzel                     kolrabi@gmx.de
   
    Bjrn Paetzel
	Gelsenkircher Str. 66
	D-44649 Herne

  ------------------------------------------------------------------------

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation;  either  version 2 of the  License, or
    any later version.

    This program is distributed in the hope that it  will be useful, but
    WITHOUT  ANY  WARRANTY;  without   even  the  implied   warranty  of
	MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU
    General Public License for more details.
	
	You should have received a copy  of the  GNU  General Public License
    along with this program (GPL.TXT); if not, write to the 

	Free Software Foundation, Inc., 
	59 Temple Place, Suite 330, 
	Boston, MA
    02111-1307, USA.
*/

// ---------------------------------------------------------- //
// clientsockets.h

#ifndef _WIN32

#define			SOCKET			int
#define			INVALID_SOCKET	-1
#define			SOCKET_ERROR	-1
#define			HOSTENT			struct hostent
#define			SOCKADDR		struct sockaddr
#define         SOCKADDR_IN		struct sockaddr_in

#define			closesocket(a) close(a)

#endif

// ---------------------------------------------------------- //
// types

#ifndef		CLIENTSOCKET_TYPES_DEFINED
#define		CLIENTSOCKET_TYPES_DEFINED

typedef struct _server_s
{
	char				name[64];
	unsigned int		port;
	SOCKET				sock;
	unsigned int		portstocheck;
} server_t;

#endif

// ---------------------------------------------------------- //
// port states

#define			PORT_CLOSED		0
#define			PORT_OPEN		1
#define			PORT_FILTERED	2
#define			PORT_UNFILTERED 4
#define			PORT_UNKNOWN	-1

// ---------------------------------------------------------- //
// variables

extern  server_t	*serverlist;
extern	int			servercount;
extern  int			portstates[65536];

// ---------------------------------------------------------- //
// functions

void	initialise_sockets();
void	shutdown_sockets();
void	make_connection( char *name, long beginport, long endport );
void	fill_server_list();

