/*  Copyright (C) 2001Bjrn Paetzel                     kolrabi@gmx.de
   
    Bjrn Paetzel
	Gelsenkircher Str. 66
	D-44649 Herne

  ------------------------------------------------------------------------

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation;  either  version 2 of the  License, or
    any later version.

    This program is distributed in the hope that it  will be useful, but
    WITHOUT  ANY  WARRANTY;  without   even  the  implied   warranty  of
	MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU
    General Public License for more details.
	
	You should have received a copy  of the  GNU  General Public License
    along with this program (GPL.TXT); if not, write to the 

	Free Software Foundation, Inc., 
	59 Temple Place, Suite 330, 
	Boston, MA
    02111-1307, USA.
*/

// ---------------------------------------------------------- //
// config.h

#ifdef _WIN32
#define	DSCANVERSION	"0.1.0.win32" 
#else
#define	DSCANVERSION	"0.1.0.unix" 
#endif

#define DSCANBUILDTIME	__DATE__ " " __TIME__

// ---------------------------------------------------------- //
// types

#ifndef CONFIG_TYPES_DEFINED
#define CONFIG_TYPES_DEFINED

// config types

typedef enum _vartype
{
	vt_boolean,
	vt_int,
	vt_long,
	vt_float,
	vt_string
} vartype;

typedef	struct _config_s
{
	char	*name;
	vartype	type;
	void	*var;
	int		size;
	char	*defaultval;
} config_t;

#endif

// ---------------------------------------------------------- //
// variables in config.c

extern	config_t	configvars[];

#ifdef _SERVER

extern  char		configfile[];
extern	int			debuglevel;
extern	int			blocksize;
extern	int			listenport;
extern	char		localaddress[16];

#else

extern	char		configfile[];
extern	int			debuglevel;
extern	char		address[16];
extern	char		servers[];

extern	int			randomizescan;
extern	int			beginport;
extern	int			endport;
extern	int			scandelay;
extern  int			porttimeout;
extern  int			scantype; /* standard connect scan */

#endif

// ---------------------------------------------------------- //
// functions in config.c

void	parse_config_line( const char *line, int linenum );
int	read_config_file( char *name );
void	parse_command_line( int argc, char *argv[] );
int     check_options(void);
